/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

function onPolicyIndexChanged(){
    var cb = document.getElementById("krbPolicyIndex");
    var policy = cb.options[cb.selectedIndex].innerHTML;
    if (cb.selectedIndex==0) {
    	denyPasswordExpirationDateChanging(false);
    	showPasswordExpirationDateWarning(false);
        return;
    }
    sendAjaxRequest("getPolicyMaxLife",policy);
}

function createRequestObject() {
    if (typeof XMLHttpRequest === 'undefined') {
	XMLHttpRequest = function() {
	    try { return new ActiveXObject("Msxml2.XMLHTTP.6.0"); }
            catch(e) {}
            try { return new ActiveXObject("Msxml2.XMLHTTP.3.0"); }
            catch(e) {}
            try { return new ActiveXObject("Msxml2.XMLHTTP"); }
            catch(e) {}
            try { return new ActiveXObject("Microsoft.XMLHTTP"); }
            catch(e) {}
            throw new Error("This browser does not support XMLHttpRequest.");
        };
    }
    return new XMLHttpRequest();
}
                                                                            
                                        
var http = createRequestObject();

                                        
function sendAjaxRequest(request,params) {
var suffix = 'request=' + request;
if (params)
    suffix += "&params="+params;
http.open('get', 'modules/kerberos/kerberos/ajaxPrincipalRequests.php?'+suffix);
http.onreadystatechange = handleResponse;
http.send(null);
}
                                                    
function handleResponse() {
    if(http.readyState != 4)
	return;
    var response = http.responseText;
    var re = /^id=(\w+)&value=(\w*)/;
    var params = re.exec(response);
    
    var id = params[1];
    var value = params[2];
	
    switch (id){
        case 'getPolicyMaxLife':
    	denyPasswordExpirationDateChanging(value > 0);
    	showPasswordExpirationDateWarning(value);
	break;
    }
}

function denyPasswordExpirationDateChanging(isDenied) {
    document.getElementById("hasPasswExpDate").disabled = isDenied;
    document.getElementById("krbPassExpDate").disabled = isDenied;
    document.getElementById("krbPassExpDate_button").disabled = isDenied;
}

function getDateTimeStamp(strdate) {
    var re = /(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
    var times = re.exec(strdate);
    var date = new Date(times[1],Number(times[2])-1,times[3],times[4],times[5],times[6]);

    return Number(date);
}

function rightJustified(string, width, char){
    var result="";
    for(var i=0;i<width-string.length;i++)
	result += char;
    result+=string;
    return result;
}

function getDateFromTimeStamp(ts){
    var d = new Date(ts);
    var year = d.getFullYear();
    var month = rightJustified((d.getMonth()+1).toString(),2,"0");
    var date = rightJustified(d.getDate().toString(),2,"0");
    var hours = rightJustified(d.getHours().toString(),2,"0");
    var minutes = rightJustified(d.getMinutes().toString(),2,"0");
    var seconds = rightJustified(d.getSeconds().toString(),2,"0");
    return year+"-"+month+"-"+date+" "+hours+":"+minutes+":"+seconds;
}


function isAddPrincipal(){
    return (document.getElementsByName("lastPasswChanging").length == 0);
}

function isPasswordChanging(){
    return (isAddPrincipal() || document.getElementById("isPasswChanged").checked==true);
}

function showPasswordExpirationDateWarning(maxPasswordLife) {
    showWarning = (maxPasswordLife > 0)?"inline":"none";
    document.getElementById("commentdiv").style.display=showWarning;
    if (!showWarning)
	return;
    
    document.getElementById("commentid").innerHTML = document.getElementsByName("comment")[0].value;
    
    var passwChangingDates = document.getElementsByName("lastPasswChanging");
    var ts;
    if ((passwChangingDates.length > 0)){
        ts = getDateTimeStamp(passwChangingDates[0].value);
        ts += maxPasswordLife*1000;
        var date = getDateFromTimeStamp(ts);
        document.getElementById("commentDateId").innerHTML=date;
        //comment += "<br>" + '<span style="color: orange"> id="commentDateId"' + date + "</span>" + " will be set as the password expiration date";
    }

}

