<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/**
 * date input template
 */
class RemainingTimeTpl extends InputTpl {
    
    function RemainingDateTpl($name) {
        $this->name = $name;
    }

    function display($arrParam) {
	print '<div id="div'.$this->name.'">';
        //print '<table cellspacing="0">';
        $i = 0;
        foreach (array('days'=>array(_T('Days: ',"kerberos"), 4), 'hours'=>array(_T('Hours: '), 2), 
        'minutes'=>array(_T('Minutes: '), 2), 'seconds'=>array(_T('Seconds: '), 2)) as $elem=>$a_params) {
            $e = new InputTpl($this->name.'_'.$elem,'/^\d*$/');
            $e->setSize($a_params[1]);
            print $a_params[0];

            $e->display(array('value'=>$arrParam[$elem], 'onchange'=>'
                var elem = document.getElementById("'.$this->name.'");
                var date = elem.value;
                var part = '.$i.';
                var value = document.getElementById("'.$this->name.'_'.$elem.'").value;
                var newdate = changePartDate(date, part, value);
                elem.value = newdate;
            '));
            $i += 1;
        }
        print '<input name="'.$this->name.'" id="'.$this->name.'" type="hidden" value="'.$this->stringValue($arrParam).'"/>';
        //print '</table>';
        print '</div>';

        print '<script type="text/javascript">
                function changePartDate(date, part, value) {
                    var re = new RegExp("/", "g");
                    var adate = date.split(re);
                    adate[part] = value;
                    return adate.join("/");
                }
               </script>';

    }
    
    private function stringValue($value){
	$days = $value["days"]?$value["days"]:0;
	$hours = $value["hours"]?$value["hours"]:0;
	$minutes = $value["minutes"]?$value["minutes"]:0;
	$seconds = $value["seconds"]?$value["seconds"]:0;
	
	return sprintf("%s/%s/%s/%s",$days,$hours,$minutes,$seconds);
    }
    
    
    static function valueFromSeconds($seconds){
	$t=$seconds;

	$MaxDaysCount = 99999;
	$times = array("seconds"=>60,"minutes"=>60,"hours"=>24, "days"=>$MaxDaysCount);

	$result = array();
	foreach ($times as $name => $maxval){
	    $rem = $t % $maxval;
	    $result[$name]=$rem?$rem:"";
	    $t/=$maxval;
	}
	return $result;
    }
    
    static function secondsFromValue($value){
	$times = array(60*60*24,60*60, 60, 1);
	$values = split("/",$value);
	$result = 0;
	foreach ($values as $index => $val)
	    $result+=$times[$index]*$val;
	
	
	return $result;
    }
    
    
}

class VerifiableDynamicDateTpl extends DynamicDateTpl{
    var $badVerifyMessage;
    
    function VerifiableDynamicDateTpl($name, $badVerifyMessage = ""){
	$this->name = $name;
	$this->badVerifyMessage = $badVerifyMessage;
    }

    function display($arrParam) {
        $e = new InputTpl($this->name);
        if (!isset($GLOBALS["__JSCALENDAR_SOURCED__"])) { // to avoid double-sourcing
            $GLOBALS["__JSCALENDAR_SOURCED__"] = 1;
            print '
            <script type="text/javascript" src="graph/jscalendar/js/calendar_stripped.js"></script>
            <script type="text/javascript" src="graph/jscalendar/js/calendar-setup_stripped.js"></script>
            <style type="text/css">@import url("graph/jscalendar/css/calendar-blue.css");</style>
            <script type="text/javascript" src="graph/jscalendar/lang/calendar-en.js"></script>
            <script type="text/javascript" src="modules/kerberos/includes/verifiabledate.js"></script>
            ';

            if (isset($_REQUEST["lang"])) { // EN calendar always read, as the next one may not exists
                $extention = substr($_REQUEST["lang"], 0, 2); // transpose LANG, f.ex. fr_FR => fr
                print '
                <script type="text/javascript" src="graph/jscalendar/lang/calendar-'.$extention.'.js"></script>
                ';
            }
        }

        print '
            <span id="container_input_'.$this->name.'">
                <input name="'.$this->name.'" id="'.$this->name.'" type="' . $this->fieldType . '" class="textfield" size="'.$this->size.'" value="'.$arrParam["value"].'" readonly=1 onchange = "verifyDate(\''.$this->name.'\');" />
                <input
                    type="image"
                    style="vertical-align: bottom;"
                    src="graph/jscalendar/img/calendar.png"
                    id="'.$this->name.'_button"
                />
                <input name="'.$this->name.'_msg_keeper" id="'.$this->name.'_msg_keeper" type="hidden" value="'.$this->badVerifyMessage.'" />
                <font color="#f62217">
                <text id="'.$this->name.'_msg_elem"></text>
                </font>
        ';
                
        // ugly gettext workaround
        if (isset($arrParam["ask_for_now"])) {
            print _("or <a href='#'");
            print " onclick='javascript:document.getElementById(\"".$this->name."\").";
            print _("value=\"now\";'>now</a>");
        } elseif (isset($arrParam["ask_for_never"])) {
            print _("or <a href='#'");
            print " onclick='javascript:document.getElementById(\"".$this->name."\").";
            print _("value=\"never\";'>never</a>");
        }
        print '
            </span>';

        print '
            <script type="text/javascript">
            Calendar.setup({
            inputField      :   "'.$this->name.'",
            ifFormat        :   "%Y-%m-%d %H:%M:00",       // format of the input field
            showsTime       :   true,
            timeFormat      :   "24",
            button          :   "'.$this->name.'_button",
            firstDay        :   1,
            weekNumbers     :   false
            });
            verifyDate("'.$this->name.'");
            </script>';

    }
    

}

class PolicySelectItem extends SelectItem {
    var $additionalParams;

    function PolicySelectItem($idElt, $jsFunc = null, $style = null) {
        $this->id=$idElt;
        $this->name=$idElt;
        $this->jsFunc = $jsFunc;
        $this->style = $style;
        $this->additionalParams = null;
     }

    function setAdditionalParams($params){
	$this->additionalParams = $params;
    }

    function display($paramArray = null){
	print "<select";
        if ($this->style) {
            print " class=\"".$this->style."\"";
        }
        if ($this->jsFunc) {
    	    print " onchange=\"".$this->jsFunc."(";
    	    if ($this->jsFuncParams) {
    		print implode(", ", $this->jsFuncParams);
    	    }
    	    print "); return false;\"";
        }

        if ($this->additionalParams) {
    	    print " ".$this->additionalParams;
        }

        print " name=\"".$this->id."\" id=\"".$this->id."\">\n";
        $this->displayContent($paramArray);
        print "</select>\n";

    }
}
?>
