<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>

<?php
function parseFromKerberosDate($kerberosDate){
    $kerberosPattern=
		'/
		^(?P<weekDay>\w+)\s+
		(?P<month>\w+)\s+
		(?P<day>\w+)\s+
		(?P<hour>\d+):
		(?P<minute>\d+):
		(?P<second>\d+)\s+
		(?P<timeZone>\w+)\s+
		(?P<year>\d+)$
		/x';
    preg_match($kerberosPattern,$kerberosDate,$dateInfo);
    return $dateInfo;
}

function parseFromDynamicDateTpl($ddtDate){
    $ddtPattern=
		'/
		^(?P<year>\d+)-
		(?P<month>\d+)-
		(?P<day>\w+)\s+
		(?P<hour>\d+):
		(?P<minute>\d+):
		(?P<second>\d+)$
		/x';
    preg_match($ddtPattern,$ddtDate,$dateInfo);
    return $dateInfo;
}


function dynamicDateTplFormat(){
    return "Y-m-d H:i:s";
}

function kerberosDateFormat(){
    return "M j, Y H:i:s";
}

function kerberosDateTimeStamp($date){
    $months = array ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
    $info = parseFromKerberosDate($date);
    return mktime($info["hour"],$info["minute"],$info["second"],array_search($info["month"],$months)+1,$info["day"],$info["year"]);

}

function dynamicDateTplToKerberosDate($ddtDate){
    $info = parseFromDynamicDateTpl($ddtDate);
    $result = date(kerberosDateFormat(),
		   mktime($info["hour"],$info["minute"],$info["second"],$info["month"],$info["day"],$info["year"]));
    return $result;
}


function kerberosDateToDynamicDateTpl($kerberosDate){
    return date(dynamicDateTplFormat(),kerberosDateTimeStamp($kerberosDate));

}




?>    
