<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id$
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?

require_once("modules/kerberos/includes/kerberos.inc.php");
require_once("modules/kerberos/includes/gui.inc.php");
require_once("modules/kerberos/includes/kerberos-xmlrpc.inc.php");
require_once("modules/kerberos/includes/user-xmlrpc.inc.php");

/**
 * If user has kerberos attributes, deletes kerberos attributes and user's principal
 */
      
function _kerberos_delUser($uid) {
    global $error;
    if (hasKrbAttr($uid)) { 

	$ret = delKrbAttr($uid); 

	if (!isXMLRPCError()) {
	  if ($ret != 0) {
	      $error .= _T("Deleting Kerberos principal failed", "kerberos");
	  }
	  return $ret;    
	}
    }
    return 0;
}

/**
 * Enabled user's kerberos principal
 */

function _kerberos_enableUser($paramsArr) {
    return xmlCall("kerberos.enableUser", $paramsArr);
}

/**
 * Disables user's kerberos principal
 */

function _kerberos_disableUser($paramsArr) {
    return xmlCall("kerberos.disableUser", $paramsArr);
}

/**
 * If user has kerberos attributes, changes kerberos password
 */
        
function _kerberos_changeUserPasswd($paramsArr) {

    global $error;
    if ($error) return -1;
    if (hasKrbAttr($paramsArr[0])) {
	$result = changeKrbPassword($paramsArr);
	if (!isXMLRPCError()) {
	    if (!$result["changed"]) {
		$error .= _T("Changing Kerberos password failed", "kerberos")."<br />\n";
		if (array_key_exists("password errors",$result)) {
		    if ($result["password errors"]["minimum length error"]) {
			$error .= _T("The password is too short for this policy", "kerberos");
		    }	
		    else if ($result["password errors"]["minimum classes error"]) {
			$error .= _T("The password does not contain enough character classes for this policy", "kerberos");
		    }	
		    else if ($result["password errors"]["reuse error"]) {
			$error .= _T("Can't reuse password", "kerberos");
		    }	
		    setFormError("pass");	  
		}
		return -1;
	    }
	}    
    return 0;
    }
}

/**
 * If user has no kerberos attributes, creates kerberos principal for user
 * Changes principal's password policy, expiration date, password expiration date
 *
 */
 
function _kerberos_changeUser($FH, $mode) {
    global $error;
    if ($error) return -1;

    $policy = $FH->getPostValue("krbPolicyIndex");
    if ($policy == _T("[none]", "kerberos")) {
	$policy = "";
    }
    
    $expDate = $FH->getPostValue("krbExpDate");
    if (!$FH->getPostValue("hasExpDate")) {
        $expDate = 'never';
    }

    $passExpDate = $FH->getPostValue("krbPassExpDate");
    if (!$FH->getPostValue("hasPasswExpDate")) {
        $passExpDate = 'never';
    }
    
    $uid = $FH->getPostValue("uid");
    if (!hasKrbAttr($uid)) { //if it is not a Kerberos principal
	global $result;
        global $error;

        $ret = addKrbAttr($uid, $FH->getPostValue("pass"), $policy, $expDate, $passExpDate);

  	if (!isXMLRPCError()) {
	    if (!$ret["added"]) {
		$error .= _T("Adding Kerberos attributes failed", "kerberos")."<br />\n";
		if (array_key_exists("password errors",$ret)) {
		    if ($ret["password errors"]["minimum length error"]) {
			$error .= _T("The password is too short for this policy", "kerberos");
		    }	
		    else if ($ret["password errors"]["minimum classes error"]) {
			$error .= _T("The password does not contain enough character classes for this policy", "kerberos");
		    }	
		    else if ($ret["password errors"]["reuse error"]) {
			$error .= _T("Can't reuse password", "kerberos");
		    }	
		    setFormError("pass");	  		
		}
		return -1;
	    }
	    else {
	        $result .= _T("Kerberos attributes added.", "kerberos")."<br />";    	    
	    }
	}
    }
    else
    {    
        $ret = changeKrbAttr($uid, $policy, $expDate, $passExpDate);
        if (!isXMLRPCError()) {
	    if ($ret["modified"]) {
	        $result .= _T("Kerberos attributes modified", "kerberos")."<br />";    	    
	    }
            else {
		$error .= _T("Changing Kerberos attributes failed", "kerberos");
		return -1;
	    }
        }
    }    

    return 0;    
}
    
/**
 * If user has no kerberos attributes, checks if principal with name = user's uid exist and if user has entered his password
 */
    
function _kerberos_verifInfo($FH, $mode) {
    global $error;
    if ($error) return -1;
    
    if (!hasKrbAttr($FH->getPostValue("uid"))) {
        if (isPrincipalExists($FH->getPostValue("uid"))) {
	    $error .= _T("Principal already exists", "kerberos")."<br />\n";
	    setFormError("uid");
            return -1;           
        }  

	if ($FH->getPostValue("pass") == "") { // we need a password
    	    $error .= _T("You must enter your password", "kerberos")."<br />\n";
            setFormError("pass");
	    return -1;
        }
    }
}
?>
<?php

/**
 * Output of kerberos attributes
 */


function _kerberos_baseEdit($FH,$mode) {
?>
<script type="text/javascript" src="modules/kerberos/includes/ajaxPrincipalHandler.js"></script>
<?php

    $checked = "checked"; //default value
    $displayType = "inline";

    /* Kerberos password policy */
    $policies = getPoliciesList();
    array_unshift($policies, _T("[none]", "kerberos"));
    $policy = _T("[none]", "kerberos");     
  
    $uid = $FH->getArrayOrPostValue("uid");

    if ($mode == "edit") {
	$principalName = $FH->getArrayOrPostValue("krbPrincipalName");
	$info = getPrincipal($principalName);
	
	if ($info){
            $policy = $info["Policy"];
    
            $sourceExpDate = $info["Expiration date"];
            $hasExpDate = ($sourceExpDate != "[never]");
            $expDate = $hasExpDate?kerberosDateToDynamicDateTpl($sourceExpDate):date(dynamicDateTplFormat());
                            
            $sourcePassExpDate = $info["Password expiration date"];
            $hasPassExpDate = ($sourcePassExpDate != "[none]");
            $passExpDate = $hasPassExpDate?kerberosDateToDynamicDateTpl($sourcePassExpDate):date(dynamicDateTplFormat());
    	}
    } else {
        $hasExpDate = "";
        $expDate = date(dynamicDateTplFormat());
        $policy = (array_search("default", $policies))?"default":_T("[none]");
        $hasPasswExpDate = "";
        $passwExpDate = date(dynamicDateTplFormat());
    }


    $f = new DivForModule(_T("Kerberos user properties","kerberos"), "#FFF5F4");
    $f->push(new Table());

    if ($mode == "edit")  {
	$f->add(new TrFormElement(_T("User principal's name", "kerberos"),new HiddenTpl("krbPrincipalName"),
            	    array("tooltip" => _T("Kerberos principal's name", "kerberos"),"cssErrorName" => "krbPrincipalName")),
        	array("value"=>$principalName));
    }    

    $policySI = new PolicySelectItem("krbPolicyIndex", "onPolicyIndexChanged()");
    $policySI->setElements($policies);
    $policySI->setElementsVal($policies);
    $policySI->setAdditionalParams("onkeyup=\"this.blur();this.focus();\"");
    $policySI->setSelected($policy);
    
    $f->add(new TrFormElement(_T("Kerberos password policy", "kerberos"), $policySI));

    /* Principal expiration */
    $checked = $hasExpDate?"checked":"";

    $f->add(new TrFormElement(_T("Principal has expiration date, if checked", "kerberos"), new CheckboxTpl("hasExpDate")),
	    array("value"=>$checked, "extraArg"=>'onclick="toggleVisibility(\'expdiv\');"'));
	                                                        
    $f->pop();


    $expdiv = new Div(array("id" => "expdiv"));
    $expdiv->setVisibility($checked);
    
    $f->push($expdiv);
    $f->push(new Table());

    $f->add(new TrFormElement(_T("Expiration date"), new VerifiableDynamicDateTpl("krbExpDate",_T("Expired", "kerberos"))),
    	    array("value" => $expDate));
    
    $f->pop();
    $f->pop();

    $f->push(new Table());

    $checked = $hasPassExpDate?"checked":"";

    $f->add(new TrFormElement(_T("Principal has password expiration date, if checked", "kerberos"), 
				new CheckboxTpl("hasPasswExpDate")),
	    array("value"=>$checked, "extraArg"=>'onclick="toggleVisibility(\'passexpdiv\');"'));
    $f->pop();

    $passwexpdiv = new Div(array("id" => "passexpdiv"));
    $passwexpdiv->setVisibility($checked);

    $f->push($passwexpdiv);

    $f->push(new Table());
    $f->add(
	new TrFormElement(_T("Password expiration date"), new VerifiableDynamicDateTpl("krbPassExpDate",_T("Expired", "kerberos"))),
	array("value" => $passExpDate)
    );
    $f->pop();

    $f->pop();


    $commentdiv = new Div(array("id" => "commentdiv"));
    $commentdiv->setVisibility("");
    $f->push($commentdiv);
    $f->add(new TrFormElement('<div align = "center"><strong id="commentid"></strong></div>',new HiddenTpl("comment")),
	    array("value"=>_T("Attention! The settings of choosen policy don't allow to set the password expiration date"), "hide"=>"1")
	    ); 
    $f->pop();

    $f->push(new Table());
    $f->pop();


    //need to run function which adjust policy depended settings after creation of elements of $f
    echo '<script type="text/javascript">setTimeout("onPolicyIndexChanged()",1);</script>'; 
    //echo '<script type="text/javascript">onPolicyIndexChanged();</script>'; 

    return $f;    
}

?>