<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

 
require("../../../includes/config.inc.php");
require("../../../includes/i18n.inc.php");
require("../../../includes/acl.inc.php");
require("../../../includes/session.inc.php");
require("../../../modules/kerberos/includes/kerberos-xmlrpc.inc.php");
require("../../../modules/kerberos/includes/kerberos.inc.php");
require("../../../includes/PageGenerator.php");

function isRequiredPrincipal($princ){
    $requiredPatterns = array("/^K\\/M/", "/^krbtgt\\//", "/^kadmin\\//", "/^ldap\\//");

    foreach ($requiredPatterns as $pattern){
	if (preg_match($pattern, $princ)){
	    return 1;
	}
    }
    return 0;
}




$filter = $_GET["filter"];
$principals = getPrincipalsList($filter);

$types = array();
$policies = array();
$expDates = array();
$passwExpDates = array();

$delActions = array();
$defaultDelAction = new ActionPopupItem(_T("Delete principal", "kerberos"),"deleteprincipal","delete","principal", "kerberos", "kerberos");
$emptyAction = new EmptyActionItem();


global $conf;
$maxperpage=$conf["global"]["maxperpage"];
$start = isset($_GET["start"])?$_GET["start"]:0;
    
$itemsatpage = count($principals)-$start>$maxperpage?$maxperpage:count($principals)-$start;
$principalsatpage = array_slice($principals,$start,$itemsatpage);

foreach ($principalsatpage as $p){
    $info = getPrincipal($p);
    $hasPolicy = $info["Policy"]!="[none]";
    $policies[] = $hasPolicy?$info["Policy"]:_T("none","kerberos");
    
    
    $hasExpDate = $info["Expiration date"]!="[never]";
    $expDate = _T("never","kerberos");
    if ($hasExpDate){
	$expDate = kerberosDateToDynamicDateTpl($info["Expiration date"]);
	if (kerberosDateTimeStamp($info["Expiration date"])<=time())
	    $expDate = '<FONT COLOR="#f62217">'.$expDate."</font>";
    }
    
    $expDates[] = $expDate;

    $hasPasswExpDate = $info["Password expiration date"]!="[none]";
    $passwExpDate = _T("never","kerberos");
    if ($hasPasswExpDate){
	$passwExpDate = kerberosDateToDynamicDateTpl($info["Password expiration date"]);
	if (kerberosDateTimeStamp($info["Password expiration date"])<=time())
	    $passwExpDate = '<FONT COLOR="#f62217">'.$passwExpDate."</font>";
    }

    $type = "";
    $delAction=$defaultDelAction;
    
    if (isRequiredPrincipal($p)){
	$type = _T("Administrative", "kerberos");
	$delAction = $emptyAction;
    }	
    
    if (isPrincipalForUser($p)){
	$type = _T("User", "kerberos");
	$delAction = $emptyAction;
    }
    
    $types[] = $type;
    $delActions[] = $delAction;
    $passwExpDates[] = $passwExpDate;
}

$l = new OptimizedListInfos($principalsatpage, _T("Principals", "kerberos"));
$l->setName(_T("Principals","kerberos"));
$l->setItemCount(count($principals));
$l->start = 0;
$l->end = count($principalsatpage)-1;

$l->setNavBar(new AjaxNavBar(count($principals), $filter));


$l->addExtraInfo($types,_T("Type","kerberos"));
$l->addExtraInfo($policies,_T("Policy","kerberos"));
$l->addExtraInfo($expDates,_T("Expiration date","kerberos"));
$l->addExtraInfo($passwExpDates,_T("Password expiration date","kerberos"));

$l->addActionItem(new ActionItem(_T("Edit principal information", "kerberos"),"editprincipal","edit","principal", "kerberos", "kerberos"));
$l->addActionItem(new ActionItem(_T("Handle keytab", "kerberos"),"handlekeytab","backup","principal", "kerberos", "kerberos"));
#$l->addActionItem(new ActionPopupItem(_T("Delete principal", "kerberos"),"deleteprincipal","delete","principal", "kerberos", "kerberos"));
$l->addActionItemArray($delActions);

$l->display();
/*var_dump($conf);
phpinfo(32);
print_r($session);
echo $start." ";
echo $itemsatpage." ";
*/
?>

