<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

require_once("modules/kerberos/includes/gui.inc.php");
require_once("modules/kerberos/includes/kerberos-xmlrpc.inc.php");
require("modules/kerberos/kerberos/localSidebar.php");
require("graph/navbar.inc.php");



if (isset($_POST["bcreate"])) {
    $name = $_POST["name"];
    $maxlife = RemainingTimeTpl::secondsFromValue($_POST["maxlife"]);
    $minlife = RemainingTimeTpl::secondsFromValue($_POST["minlife"]);
    $minlength = $_POST["minlength"];
    $minclasses = $_POST["minclasses"];
    //print_r($_POST);
    $error = "";
    if ($maxlife < $minlife){
	$error.= _T("Minimum password life can't be more than maximum password life");
	$error.="<br>";
    }
    if (isPolicyExists($name))
	$error = _T("Policy already exists");
    if ($error)
	new NotifyWidgetFailure($error);
    else {
	$isAdded = addPolicy($name, $maxlife, $minlife, $minlength, $minclasses);
	if (!isXMLRPCError()) {
	    if (!$isAdded)
		new NotifyWidgetFailure(sprintf(_T("Can't create policy %s"),$name));
	    else {
    		new NotifyWidgetSuccess(sprintf(_T("Policy %s was successfully created"), $name));
    		header("Location: ". urlStrRedirect("kerberos/kerberos/policies"));
    	    }
	}
	    
    }

}


if (isset($_POST["bedit"])){
    $name = $_POST["name"];
    $maxlife = RemainingTimeTpl::secondsFromValue($_POST["maxlife"]);
    $minlife = RemainingTimeTpl::secondsFromValue($_POST["minlife"]);
    $minlength = $_POST["minlength"];
    $minclasses = $_POST["minclasses"];
    //echo sprintf("%s %s %s %s %s", $name, $maxlife, $minlife, $minlength, $minclasses);
    $error = "";
    if ($maxlife < $minlife){
	$error.= _T("Minimum password life can't be more than maximum password life");
	new NotifyWidgetFailure($error);
    }
    else {
	$isModified = modifyPolicy($name, $maxlife, $minlife, $minlength, $minclasses);
	if (!isXMLRPCError()) {
    	    if (!$isModified)
		new NotifyWidgetFailure(sprintf(_T("Can't modify policy %s"),$name));
	    else {
    		new NotifyWidgetSuccess(sprintf(_T("Policy %s was successfully modified"), $name));
    		header("Location: ". urlStrRedirect("kerberos/kerberos/policies"));
	    }
	}
    }
}

if ($_GET["action"] == "addpolicy")
    $title = _T("Add a kerberos policy");
else
    $title = _T("Edit policy");

if (isset($_POST["bcreate"]) || isset($_POST["bedit"])) {
    $name=$_POST["name"];
    $maxlife = RemainingTimeTpl::secondsFromValue($_POST["maxlife"]);
    $minlife = RemainingTimeTpl::secondsFromValue($_POST["minlife"]);
    $minlength = $_POST["minlength"];
    $minclasses = $_POST["minclasses"];
} else if ($_GET["action"] == "addpolicy") {
    $name = "";
    $maxlife = 0;
    $minlife = 0;
    $minlength = 1;
    $minclasses = 1;
} else {
    $name = urldecode($_GET["policy"]);
    $info = getPolicy($name);
    $maxlife = $info["Maximum password life"];
    $minlife = $info["Minimum password life"];
    $minlength = $info["Minimum password length"];
    $minclasses = $info["Minimum number of password character classes"];
}


$p = new PageGenerator($title);
$p->setSideMenu($sidemenu);
$p->display();

$f = new ValidatingForm();

$f->push(new Table());
if ($_GET["action"] == "addpolicy")  {
    $nameTpl = new InputTpl("name","/^\w+[a-zA-Z0-9\/\:_\.\!\-@ ]*$/");
} else {
    $nameTpl = new HiddenTpl("name");
}

$f->add(
    new TrFormElement(_T("Name"), $nameTpl),
    array("value" => $name, "required" => "1")
	);

$f->add(
	new TrFormElement(_T("Maximum password life"), new RemainingTimeTpl("maxlife")),
	RemainingTimeTpl::valueFromSeconds($maxlife)
	);

$f->add(
	new TrFormElement(_T("Minimum password life"), new RemainingTimeTpl("minlife")),
	RemainingTimeTpl::valueFromSeconds($minlife)
	);

$minlifeTpl = new InputTpl("minlength","/^\d+$/");
$minlifeTpl->setSize(1);
$f->add(
	new TrFormElement(_T("Minimum password length"), $minlifeTpl),
	array("value" => $minlength, "required" => "1")
	);

$minclassesTpl = new InputTpl("minclasses","/^[1-5]$/");
$minclassesTpl->setSize(1);

$f->add(
	new TrFormElement(_T("Minimum number of password character classes"), $minclassesTpl, array("tooltip" => _T("Number ranges from 1 to 5", "kerberos"))),
	array("value" => $minclasses,"required" => "1")
	);

if ($_GET["action"] == "addpolicy")
    $f->addButton(bcreate,_("Create"));
else 
    $f->addButton(bedit,_("Confirm"));

$f->pop();

$f->display();

?>


