<script type="text/javascript" src="modules/kerberos/includes/ajaxPrincipalHandler.js"></script>

<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */


require_once("modules/kerberos/includes/kerberos.inc.php");
require_once("modules/kerberos/includes/gui.inc.php");


require_once("modules/kerberos/includes/kerberos-xmlrpc.inc.php");
require("modules/kerberos/kerberos/localSidebar.php");
require("graph/navbar.inc.php");



$policies = getPoliciesList();
array_unshift($policies,_T("[none]","kerberos"));

if (isset($_POST["bcreate"])) {
    $name = $_POST["name"];
    $passw = $_POST["passw"];
    $passw2 = $_POST["passw2"];
    $isRandomPassw = isset($_POST["isRandomPassw"])?True:False;
    $policyName = ($_POST["krbPolicyIndex"]==0)?null:$policies[$_POST["krbPolicyIndex"]];
    //$expDate = isset($_POST["hasExpDate"])?dynamicDateTplToKerberosDate($_POST["expDate"]):"never";
    //$passwExpDate = isset($_POST["hasPasswExpDate"])?dynamicDateTplToKerberosDate($_POST["krbPassExpDate"]):"never";
    $expDate = isset($_POST["hasExpDate"])?$_POST["expDate"]:"never";
    $passwExpDate = isset($_POST["hasPasswExpDate"])?$_POST["krbPassExpDate"]:"never";

    //print_r($_POST);
    //print "isRandomPassw is ".$isRandomPassw;

    $error = "";

    if (isPrincipalExists($name))
	$error = _T("Principal already exists");

    if (!$isRandomPassw) {
	if ($passw != $passw2) 
	    $error = _T("The confirmation password does not match the new password");
	else if (!$passw) 
	    $error = _T("Password is empty");
    }
    
    //print "error is ".$error;
    
    if ($error)
	new NotifyWidgetFailure($error);
    else {
	$result = addPrincipal($name, $isRandomPassw, $passw, $policyName, $expDate, $passwExpDate);
	if (!isXMLRPCError()) {
	    if (array_key_exists("password errors",$result)){
		 if ($result["password errors"]["minimum length error"])
		    $error .= _T("The password is too short for this policy");
		 else if ($result["password errors"]["minimum classes error"])
		    $error .= _T("The password does not contain enough character classes for this policy");
    	    }
    	    
	    if (!$result["added"]) {
		$error .= "<br>";
		$error .= _T("Can't create principal");
	    }

	    if ($error)
		new NotifyWidgetFailure($error);
	    else {
		new NotifyWidgetSuccess(sprintf(_T("Principal %s was successfully created"), $name));
    		header("Location: ". urlStrRedirect("kerberos/kerberos/index"));
    	    }
	}
    }

}


if (isset($_POST["bedit"])){
    $name = $_POST["name"];
    $passw = $_POST["passw"];
    $passw2 = $_POST["passw2"];
    $isRandomPassw = False;
    $isPasswChanged = isset($_POST["isPasswChanged"]) ? True : False;
    if ($isPasswChanged)
	$isRandomPassw = isset($_POST["isRandomPassw"]) ? True : False;
    $policyName = ($_POST["krbPolicyIndex"]==0)?null:$policies[$_POST["krbPolicyIndex"]];
    //$expDate = isset($_POST["hasExpDate"])?dynamicDateTplToKerberosDate($_POST["expDate"]):"never";
    //$passwExpDate = isset($_POST["hasPasswExpDate"])?dynamicDateTplToKerberosDate($_POST["krbPassExpDate"]):"never";
    $expDate = isset($_POST["hasExpDate"])?$_POST["expDate"]:"never";
    $passwExpDate = isset($_POST["hasPasswExpDate"])?$_POST["krbPassExpDate"]:"never";

    /*print_r($_POST);
    print "isRandomPassw is ".$isRandomPassw;
    */
    $error = "";
    if ($isPasswChanged && !$isRandomPassw) {
	if ($passw != $passw2) 
	    $error = _T("The confirmation password does not match the new password");
	else if (!$passw) 
	    $error = _T("Password is empty");
    }

    
    if ($error)
	new NotifyWidgetFailure($error);
    else {
	$result = modifyPrincipal($name, $isRandomPassw, $passw, $policyName, $expDate, $passwExpDate);
	//var_dump($result);
	if (!isXMLRPCError()) {
	    if (array_key_exists("password state",$result)&&!$result["password state"]["changed"]){
		 if ($result["password state"]["password errors"]["minimum length error"])
		    $error .= _T("The password is too short for this policy");
		 else if ($result["password state"]["password errors"]["minimum classes error"])
		    $error .= _T("The password does not contain enough character classes for this policy");
		 else if ($result["password state"]["password errors"]["reuse error"])
		    $error .= _T("Can't reuse password");
    	    }
	    if (!$result["modified"]) {
		$error .= "<br>";
		$error .= _T("Can't modify principal");
	    }
	    if ($error)
		new NotifyWidgetFailure($error);
	    else {
	    	new NotifyWidgetSuccess(sprintf(_T("Principal %s successfully modified"), $name));
    		header("Location: ". urlStrRedirect("kerberos/kerberos/index"));
    	    }
	}
	    
    }
}

if ($_GET["action"] == "addprincipal")
    $title = _T("Add a kerberos principal");
else
    $title = _T("Edit principal");

if (isset($_POST["bcreate"]) || isset($_POST["bedit"])){
    $name = $_POST["name"];
    $isPasswChanged = isset($_POST["isPasswChanged"])?"checked":"unchecked";
    $isRandomPassw = isset($_POST["isRandomPassw"])?"checked":"unchecked";
    $policy = $policies[$_POST["krbPolicyIndex"]];

    $hasExpDate = isset($_POST["hasExpDate"]);
    $hasPasswExpDate = isset($_POST["hasPasswExpDate"]);
    $expDate = isset($_POST["hasExpDate"])?$_POST["expDate"]:date(dynamicDateTplFormat());
    $passwExpDate = isset($_POST["hasPasswExpDate"])?$_POST["krbPassExpDate"]:date(dynamicDateTplFormat());
    $passwChangingDate = $_POST["lastPasswChanging"];
    
}else if ($_GET["action"] == "addprincipal") {
    $hasExpDate = "";
    $expDate = date(dynamicDateTplFormat());
    $name = "";
    $policy = (array_search("default", $policies))?"default":_T("[none]");
    $isRandomPassw = "checked";
    
    $hasPasswExpDate = "";
    $passwExpDate = date(dynamicDateTplFormat());
} else {
    $principal = urldecode($_GET["principal"]);

    $info = getPrincipal($principal);
    
    $name = $principal;
    $policy = $info["Policy"];

    $sourceExpDate = $info["Expiration date"];
    $hasExpDate = ($sourceExpDate != "[never]");
    $expDate = $hasExpDate?kerberosDateToDynamicDateTpl($sourceExpDate):date(dynamicDateTplFormat());

    $passwChangingDate = kerberosDateToDynamicDateTpl($info["Last password change"]);
    $isPasswChanged = "unchecked";
    $isRandomPassw = "checked";
    
    $sourcePasswExpDate = $info["Password expiration date"];
    $hasPasswExpDate = ($sourcePasswExpDate != "[none]");
    $passwExpDate = $hasPasswExpDate?kerberosDateToDynamicDateTpl($sourcePasswExpDate):date(dynamicDateTplFormat());
    
    $isPrincipalForUser = isPrincipalForUser($principal);
}

$p = new PageGenerator($title);
$p->setSideMenu($sidemenu);
$p->display();

$f = new ValidatingForm();

$f->push(new Table());
if ($_GET["action"] == "addprincipal")  {
    $nameTpl = new InputTpl("name","/^\w+[a-zA-Z0-9\/\:_\.\!\-@ ]*$/");
} else {
    $nameTpl = new HiddenTpl("name");
}

$f->add(
    new TrFormElement(_T("Name"), $nameTpl),
    array("value" => $name, "required" => "1")
	);


if ($_GET["action"] == "editprincipal")  {
$f->add(
        new TrFormElement(_T("Last password change date"), new HiddenTpl("lastPasswChanging")),
        array("value" => $passwChangingDate)
        );

}

if (!($isPrincipalForUser && $_GET["action"] == "editprincipal"))
{


if ($_GET["action"] == "editprincipal")  {
    $f->add(
	new TrFormElement(_T("Principal changes password, if checked"), new CheckboxTpl("isPasswChanged")),
	array("value" => $isPasswChanged, "extraArg"=>'onclick="toggleVisibility(\'passwtypediv\');onHasPasswordChanged();"')
    );

}    
$f->pop();
    
$passwtypediv = new Div(array("id" => "passwtypediv"));
$passwtypediv->setVisibility(($_GET["action"] == "editprincipal") ? "" : "checked");

$f->push($passwtypediv);

$f->push(new Table());
$f->add(
    new TrFormElement(_T("Password generates from random number, if checked"), new CheckboxTpl("isRandomPassw")),
    array("value" => $isRandomPassw, "extraArg"=>'onclick="toggleVisibility(\'passwdiv\');"')
);

$f->pop();


$passwdiv = new Div(array("id" => "passwdiv"));
$passwdiv->setVisibility("");

$f->push($passwdiv);

$f->push(new Table());


$f->add(
        new TrFormElement(_T("Password"), new PasswordTpl("passw")),
        array("value" => "")
        );
$f->add(
        new TrFormElement(_T("Confirm password"), new PasswordTpl("passw2")),
        array("value" => "")
        );

$f->pop();

$f->pop();

$f->pop();

$f->push(new Table());

}


$policySI = new PolicySelectItem("krbPolicyIndex","onPolicyIndexChanged()");
$policySI->setElements(array_values($policies));
$policySI->setElementsVal(array_keys($policies));
$policySI->setAdditionalParams("onkeyup=\"this.blur();this.focus();\"");
        
$f->add(
        new TrFormElement(_T("Policy"), $policySI),
        array("value" => array_search($policy, $policies))
        );



$checked = $hasExpDate?"checked":"";

$f->add(
        new TrFormElement(_T("Principal has expiration date, if checked"), new CheckboxTpl("hasExpDate")),
        array ("value" => $checked,"extraArg"=>'onclick="toggleVisibility(\'expdiv\');"')
        );
$f->pop();

$expdiv = new Div(array("id" => "expdiv"));
$expdiv->setVisibility($checked);
$f->push($expdiv);

$f->push(new Table());

$f->add(
        new TrFormElement(_T("Expiration date"), new VerifiableDynamicDateTpl("expDate",_T("Expired"))),
        array("value" => $expDate)
        );
$f->pop();

$f->pop();


$checked = $hasPasswExpDate?"checked":"";

$f->push(new Table());
$f->add(
  new TrFormElement(_T("Principal has password expiration date, if checked"), 
  new CheckboxTpl("hasPasswExpDate")),
  array ("value" => $checked,"extraArg"=>'onclick="toggleVisibility(\'passwexpdiv\');"')
	);

$f->pop();



$passwexpdiv = new Div(array("id" => "passwexpdiv"));
$passwexpdiv->setVisibility($checked);
$f->push($passwexpdiv);

$f->push(new Table());
$f->add(
  new TrFormElement(_T("Password expiration date"), new VerifiableDynamicDateTpl("krbPassExpDate",_T("Expired"))),
  array("value" => $passwExpDate)
);
$f->pop();


$f->pop();


$commentdiv = new Div(array("id" => "commentdiv"));
$commentdiv->setVisibility("");
$f->push($commentdiv);
//$f->push(new Table());
$f->add(
  new TrFormElement('<div align = "center"><strong id="commentid"></strong></div>',new HiddenTpl("comment")),
  array("value"=>_T("Attention! The settings of choosen policy don't allow to set the password expiration date"), "hide"=>"1")
  ); 
//$f->pop();
$f->pop();
$f->push(new Table());
$f->pop();




if ($_GET["action"] == "addprincipal")
    $f->addButton(bcreate,_("Create"));
else 
    $f->addButton(bedit,_("Confirm"));

$f->pop();

$f->display();

echo '<script type="text/javascript">onPolicyIndexChanged();</script>'; 

if (isset($_POST["bcreate"]) || isset($_POST["bedit"])){
    if (isset($_POST["isPasswChanged"]))
        echo '<script type="text/javascript">toggleVisibility(\'passwtypediv\');</script>'; 
    if (!isset($_POST["isRandomPassw"]))
        echo '<script type="text/javascript">toggleVisibility(\'passwdiv\');</script>'; 
}

?>
