<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

require_once("modules/kerberos/includes/kerberos-xmlrpc.inc.php");

require("modules/kerberos/kerberos/localSidebar.php");
require("graph/navbar.inc.php");


if (isset($_POST["bback"])) {
    header("Location: ". urlStrRedirect("kerberos/kerberos/principals"));
}

#phpinfo(32);


$keytabDir = isset($_POST["directory"])?$_POST["directory"]:"/etc/kerberos/";
$keytabFilename = isset($_POST["filename"])?$_POST["filename"]:"global.keytab";


if (isset($_POST["bcreate"])) {
    $principal = $_POST["principal"];
    $filename = $_POST["filename"];
    $directory = $_POST["directory"];
    

    $isAdded = addKeytab($principal, $directory."/".$filename);
	if (!isXMLRPCError()) {
	    if (!$isAdded)
		new NotifyWidgetFailure(sprintf(_T("Can't create keytab entry for principal %s"),$principal));
	    else {
    		new NotifyWidgetSuccess(sprintf(_T("Keytab entry for principal %s was successfully created"),$principal));
    	    }
	}
}

if (isset($_POST["bdelete"])) {
    $principal = $_POST["principal"];
    $filename = $_POST["filename"];
    $directory = $_POST["directory"];

    $result = deleteKeytab($principal, $directory."/".$filename);
	if (!isXMLRPCError()) {
	    if ($result["file exists"]) {
		if ($result["deleted"])
    		    new NotifyWidgetSuccess(sprintf(_T("Keytab entries for principal %s was successfully deleted"),$principal));
    		else if	($result["no entry"])
    		    new NotifyWidgetWarning(sprintf(_T("There is no keytab entries for principal %s in file %s"),$principal, $filename));
    		else
    		    new NotifyWidgetFailure(sprintf(_T("Can't delete keytab entries for principal %s"),$principal));
    	    } else
    		new NotifyWidgetFailure(_T("Keytab file does not exist"));
	}
}



$principal = urldecode($_GET["principal"]);

$p = new PageGenerator(_T("Kerberos principal keytab handling"));
$p->setSideMenu($sidemenu);
$p->display();

$f = new ValidatingForm();

$f->push(new Table());

$f->add(
    new TrFormElement(_T("Principal name"), new HiddenTpl("principal")),
    array("value" => $principal)
	);


$f->add(
    new TrFormElement(_T("Keytab filename"), new InputTpl("filename","/^\w+[a-zA-Z0-9\/\:_\.\!\-@ ]*$/")),
    array("value" => $keytabFilename)
	);

$dirTpl = new IA5InputTpl("directory");
$dirTpl->setSize(43);

$f->add(
	new TrFormElement(_T("Keytab directory"), $dirTpl),
	array("value" => $keytabDir)
	);
$f->pop();

$f->addButton(bcreate,_T("Add to keytab"));
$f->addButton(bdelete,_T("Delete from keytab"));
$f->addButton(bback,_T("Back"),"btnSecondary");
$f->display();

?>
