<?php
/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com
 * (c) 2011 http://www.osinit.ru
 *
 * $Id:
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

require("localSidebar.php");
require("graph/navbar.inc.php");
require("modules/kerberos/includes/services-xmlrpc.inc.php");

$p = new PageGenerator(_T("Kerberos services management", "kerberos"));
$p->setSideMenu($sidemenu);
$p->display();

/* Set the available action items according to the service status */
$params = array();
$actionsStart = array();
$actionsStop = array();
$actionsRestart = array();

$startAction = new ActionItem(_T("Start service", "kerberos"), "servicestart", "start", "");
$stopAction = new ActionItem(_T("Stop service", "kerberos"), "servicestop", "stop", "");
$restartAction = new ActionItem(_T("Restart service", "kerberos"), "servicerestart", "restart", "");
$emptyAction = new EmptyActionItem();

$status = array();

if (kdcService("status")) {
    $status[] = _T("Started", "kerberos");
    $actionsStart[] = $emptyAction;
    $actionsStop[] = $stopAction;
    $actionsRestart[] = $restartAction;
} else {
    $status[] = _T("Stopped", "kerberos");
    $actionsStart[] = $startAction;
    $actionsStop[] = $emptyAction;
    $actionsRestart[] = $emptyAction;
}

if (kadminService("status")) {
    $status[] = _T("Started", "kerberos");
    $actionsStart[] = $emptyAction;
    $actionsStop[] = $stopAction;
    $actionsRestart[] = $restartAction;
} else {
    $status[] = _T("Stopped", "kerberos");
    $actionsStart[] = $startAction;
    $actionsStop[] = $emptyAction;
    $actionsRestart[] = $emptyAction;
}

$l = new ListInfos(array("KDC", _T("Administration server", "kerberos")), _T("Services", "kerberos"));
$l-> setName(_T("Kerberos services status", "kerberos"));
$l->addExtraInfo($status, _T("Status", "kerberos"));
$l->setParamInfo(array(array("service" => "KDC"), array("service" => _T("Administration server", "kerberos"))));
$l->setTableHeaderPadding(1);
$l->disableFirstColumnActionLink();

$l->addActionItemArray($actionsStart);
$l->addActionItemArray($actionsStop);
$l->addActionItemArray($actionsRestart);
$l->display(0);

?>